﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;

namespace NorthArrowDemo
{
    public partial class Form1 : Form
    {
        private RotationProjection rotationProjection;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ShapeFileFeatureLayer shapeFileFeatureLayer = new ShapeFileFeatureLayer(@"..\..\Data\USStates.shp");
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            shapeFileFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            shapeFileFeatureLayer.FeatureSource.Projection = rotationProjection = new RotationProjection();

            shapeFileFeatureLayer.Open();
            winformsMap1.CurrentExtent = shapeFileFeatureLayer.GetBoundingBox();
            shapeFileFeatureLayer.Close();

            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.StaticOverlay.Layers.Add(shapeFileFeatureLayer);

            NorthArrowAdornmentLayer northArrowAdornmentLayer = new NorthArrowAdornmentLayer();
            winformsMap1.AdornmentOverlay.Layers.Add("northArrowAdornmentLayer", northArrowAdornmentLayer);
            winformsMap1.Refresh();
        }

        private void btnRotate_Click(object sender, EventArgs e)
        {
            double degree = double.Parse(txtDegrees.Text);
            
            rotationProjection.Angle += degree;
            winformsMap1.CurrentExtent = rotationProjection.GetUpdatedExtent(winformsMap1.CurrentExtent);
            ((NorthArrowAdornmentLayer)(winformsMap1.AdornmentOverlay.Layers["northArrowAdornmentLayer"])).RotateAngle += (float)degree;
         
            winformsMap1.Refresh();
        }
    }
}
